.386
.model	flat, stdcall
option	casemap:none

include		\GeneSys\include\windows.inc
include		\GeneSys\include\user32.inc
include		\GeneSys\include\kernel32.inc

includelib	\GeneSys\lib\kernel32.lib
includelib	\GeneSys\lib\user32.lib

CustomMsgBox	PROTO :DWORD,:DWORD,:DWORD,:DWORD
MsgboxProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD

IDB_EXIT	equ 1001
IDB_ABOUT	equ 1002

.data
msg1		db 'Customized message box with menu',0
capt		db 'Hello!',0
btext		db 'Click here',0
msg2		db 'Message box test',0
flag		dd 0

.data?
hMboxHook	dd ?
pButtonText	dd ?
pOldProc	dd ?

.code

start:

	invoke	CustomMsgBox,0,ADDR msg1,ADDR capt,ADDR btext
	invoke	ExitProcess,0

mboxCBTProc PROC uses esi nCode:DWORD,wParam:DWORD,lParam:DWORD

LOCAL rc:RECT

	cmp		nCode,0
	jl		exit
	cmp		nCode,HCBT_ACTIVATE
	jne		exit
	cmp		flag,0
	jnz		@f

	lea		esi,[rc]
	invoke	GetWindowRect,wParam,esi
	mov		eax,RECT.right[esi]
	sub		eax,RECT.left[esi]
	mov		ecx,RECT.bottom[esi]
	sub		ecx,RECT.top[esi]
	add		ecx,24
	invoke	MoveWindow,wParam,RECT.left[esi],RECT.top[esi],eax,ecx,TRUE

	invoke	GetDlgItem,wParam,IDOK
	invoke	SetWindowText,eax,pButtonText
	invoke	GetModuleHandle,0
	invoke	LoadMenu,eax,100
	invoke	SetMenu,wParam,eax

	invoke  SetWindowLong,wParam,GWL_WNDPROC,ADDR MsgboxProc
	mov		pOldProc,eax

	mov		flag,1
@@:
	xor		eax,eax
	ret	

exit:

	invoke	CallNextHookEx,hMboxHook,nCode,wParam,lParam
	ret

mboxCBTProc ENDP

CustomMsgBox PROC hWnd:DWORD,message:DWORD,caption:DWORD,buttontext:DWORD

	push	buttontext
	pop		pButtonText
	invoke	GetCurrentThreadId
	invoke	SetWindowsHookEx,WH_CBT,ADDR mboxCBTProc,NULL,eax
	mov		hMboxHook,eax
	invoke	MessageBox,0,message,caption,MB_OK
	invoke	UnhookWindowsHookEx,hMboxHook
	ret

CustomMsgBox ENDP

MsgboxProc	PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	.IF uMsg == WM_COMMAND

		.IF wParam == IDB_EXIT
			invoke	SendMessage,hWnd,WM_CLOSE,0,0

		.ELSEIF wParam == IDB_ABOUT
			invoke	MessageBox,0,ADDR msg2,ADDR capt,MB_OK

		.ENDIF

		invoke	CallWindowProc,pOldProc,hWnd,uMsg,wParam,lParam
		ret

	.ELSEIF uMsg == WM_CLOSE

		invoke  EndDialog,hWnd,0

	.ELSE

		invoke	CallWindowProc,pOldProc,hWnd,uMsg,wParam,lParam
		ret

	.ENDIF
	
	xor	eax,eax
	ret

MsgboxProc	ENDP

END start